//========================================================================
//                                 Desktop Toys
//                        a shell enhancements family
//
//                          * Open Add-on Interface *
//
//                              Version DRAFT#0.5
//                               October 31, 1996
//
//         Copyright (C) 1996 Alexander Maltsev. All rights reserved.
//		 
// Please carefully read the manual before using any of these interfaces!
//========================================================================

#ifndef __DESKTOYS_API__

#ifndef _WINDOWS
#include <windows.h>	// if not included yet
#include <commctrl.h>	// common controls, for property sheet types
#endif

//Use the key above to register your add-on at.
#define DAI_REGISTRY	"SOFTWARE\\AMP Software\\Desktop Toys\\"\
						"DesktopToys Manager\\Add-ons"

struct DAI_INFO
{
	TCHAR	m_szTitle[255];		// add-on full name (e.g. "My Great Add-on")
	TCHAR	m_szCopyr[255];		// copyright information
	HPROPSHEETPAGE m_hPage;		// handle of your property page
	                            // (use Win32 API CreatePropertySheetPage ())
	DLGPROC	m_ppageProc;		// points to your Properties sheet page handler

	DWORD	m_maskSuppFuncs;	// mask of supported functions (see below)
};

//Flags to *combine* (using binary OR -- '|') for DAI_INFO::m_maskSuppFuncs
#define DAI_FUNC_ENABLE	1		// support for Enable/Disable present
#define DAI_FUNC_ABOUT	2		// support for About dialog present
#define DAI_FUNC_REG	4		// support for Register function

//This is for internal use!
#define DAI_FUNCSHIFT	2

#ifdef __cplusplus
extern "C" {
#endif

//Required functions
BOOL CALLBACK DAIInit (DAI_INFO *pInfo, LPARAM reserved);
BOOL CALLBACK DAIRegisterAs (char *strName, char *strPath, LPARAM reserved);

//Optional functions (please note DAI_INFO::m_bSuppXXX properties on DAIInit())
BOOL CALLBACK DAIIsEnabled (LPARAM reserved);			//This TWO functions should be
BOOL CALLBACK DAIEnable (int bEnable, LPARAM reserved);	//whether supported or not.

BOOL CALLBACK DAIAbout (HWND hParent);

//Function names (MUST NOT BE CHANGED! Otherwise Desktop Toys manager will fail!)
#define DTA_FUNCNAME_INIT	"DAIInit"
#define DTA_FUNCNAME_REG	"DAIRegisterAs"

#define DTA_FUNCNAME_ENABLE	"DAIEnable"
#define DTA_FUNCNAME_ENABLED	"DAIIsEnabled"
#define DTA_FUNCNAME_ABOUT	"DAIAbout"

#ifdef __cplusplus
}	//for extern C
#endif

#endif