//========================================================================
//                                 Desktop Toys
//                        a shell enhancements family
//
//                          * Open Add-on Interface *
//
//                              Version DRAFT#0.6
//                               January 01, 1997
//
//         Copyright 1996-97 Alexander Maltsev. All rights reserved
//
// Please carefully read the manual before using any of these interfaces!
//========================================================================

{ ---------------------------------------------------------------------
         ported to Delphi 2.0 by Cyrille Chplov, 1996/11/11
 This unit is, in its interface part, a simple port of Alex Maltsev's headers

 You will have to fill in the implementation !

}

unit DT_API;
interface
uses SysUtils,Windows,CommCtrl;

//Use the key above to register your add-on at.
const
     DAI_REGISTRY = 'SOFTWARE\AMP Software\Desktop Toys\DesktopToys Manager\Add-ons';

Type
    PDAI_INFO = ^TDAI_INFO;
    TDAI_INFO = record
        m_szTitle : array[0..254] of char; // add-on full name (e.g. "My Great Add-on")
        m_szCopyr : Array[0..254] of char; // copyright information
        m_hPage : HPropSheetPage;          // handle of your property page
                                           // (use Win32 API CreatePropertySheetPage ())
	m_ppageProc : TFNDlgProc; 	   // points to your Properties sheet page handler

	m_maskSuppFuncs : DWORD;	   // mask of supported functions (see below)
    end;

//Flags to *combine* (using binary OR -- '|') for DAI_INFO::m_maskSuppFuncs
Const
     DAI_FUNC_ENABLE	= 1;		// support for Enable/Disable present
     DAI_FUNC_ABOUT	= 2;		// support for About dialog present
     DAI_FUNC_REG	= 4;		// support for Register function

//This is for internal use!
     DAI_FUNCSHIFT	= 2;

type
    TLParam = integer;

    
// Required functions
Function DAIInit(var Info : TDAI_INFO; reserved : TLparam) : Bool; stdcall;
Function DAIRegisterAs(strName,strPath : PChar; reserved : TLParam) : bool; stdcall;

//Optional functions (please note DAI_INFO::m_bSuppXXX properties on DAIInit())
Function DAIIsEnabled(reserved : TLparam) : bool; stdcall;      // These TWO functions should be
Function DAIEnable (bEnable : Bool; reserved : TLParam) : bool; stdcall; // whether supported or not.

Function DAIAbout(hParent : HWnd) : boolean; stdcall;

//Function names (MUST NOT BE CHANGED! Otherwise Desktop Toys manager will fail!)
Const
     DTA_FUNCNAME_INIT	= 'DAIInit';
     DTA_FUNCNAME_REG	= 'DAIRegisterAs';

     DTA_FUNCNAME_ENABLE  = 'DAIEnable';
     DTA_FUNCNAME_ENABLED = 'DAIIsEnabled';
     DTA_FUNCNAME_ABOUT	= 'DAIAbout';

end.
